#include <iostream>
using namespace std;


class Panel
{
public :
    int x, y;
    Panel() : x(0), y(0) {}
    Panel(int tempx, int tempy) : x(tempx), y(tempy) {}
};

class Route
{
public:
    Panel d_panel;
    Route *d_prev_p;
    Route *d_next_p;

    Route(Panel panel, Route *prev_p, Route *next_p)
        : d_panel(panel), d_prev_p(prev_p), d_next_p(next_p)
    {}
    Route() {}
};

class RouteHolder
{
private:
    Route d_start, d_end;
    int d_size;
public :
    RouteHolder() : d_size(0){
        d_start.d_next_p = &d_end;
        d_end.d_prev_p   = &d_start;
    }
    void push(Panel p)
    {
        Route *route = new Route;   //  Route NX̗̈m
        route->d_panel = p; 

        // route AXg\̈Ԍɔzu
        route->d_next_p = &d_end;
        route->d_prev_p = d_end.d_prev_p;
        d_end.d_prev_p->d_next_p = route;
        d_end.d_prev_p = route;

        d_size++;
    }

    Panel getAt(int index)
    {
        Route *search = &d_start;
        for(int i = 0; i <= index; ++i)
        {
            search = search->d_next_p;
        }
        return search->d_panel;
    }

    int getSize() { return d_size;}

    ~RouteHolder()
    {
        Route *route = d_start.d_next_p;
        while(route == &d_end)
        {
            Route *del = route;
            route = route->d_next_p;
            delete del;
        }
    }
};


int main()
{
    RouteHolder rh;
    int num = 0;

    while(true)
    {
        Panel p;
        int flag;
        cout << "x : " ; cin >> p.x;
        cout << "y : " ; cin >> p.y;
        rh.push(p);
        
        cout << "continue?  y-1, n-0 :"; cin >> flag;
        if( flag == 0) break;
    }

    int limit = rh.getSize();
    for(int i = 0; i < limit; ++i)
    {
        Panel p = rh.getAt(i);
        std::cout << p.x << " " << p.y << std::endl;
    }

    return 0;
}